﻿using System.IO;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Illusion;


public class Main : MonoBehaviour
{
    private string abPath = "";
    private string abDir;
    private List<string> abNameList = new List<string>();
    private int idx = 0;
    private int count;

    private GameObject charm;
    private WeaponController controller;

    public List<int> styleId;
    private int style = -1;
    public List<int> effectId;
    private int effect = -1;
    private int mode = -1;
    
    void Start()
    {
        if (abPath == "" || abPath == "null")
        {
            abPath = FileUtil.OpenFile();
        }
        FileInfo fileInfo = new FileInfo(abPath);
        abDir = fileInfo.DirectoryName;
        DirectoryInfo folderInfo = new DirectoryInfo(abDir);
        int t = 0;
        foreach (FileInfo NextFile in folderInfo.GetFiles())
        {
            Debug.Log(NextFile.Name);
            abNameList.Add(NextFile.Name);
            if (NextFile.Name == fileInfo.Name)
            {
                idx = t;
            }
            t++;
        }
        count = abNameList.Count;
        LoadAb(abDir + '\\' +abNameList[idx % count]);

    }

    
    void Update()
    {
        ;
    }

    void LoadAb(string abPath)
    {
        var bundle = AssetBundle.LoadFromFile(abPath);
        foreach (var name in bundle.GetAllAssetNames())
        {
            Debug.Log(name);
            charm = (GameObject)Instantiate(bundle.LoadAsset(name));
        }
        charm.transform.localScale = new Vector3(100, 100, 100);
        controller = charm.GetComponent<WeaponController>();
        charm.AddComponent<MouseControlModel>();
        styleId.Clear();
        for (int i = 0; i < controller.weaponMaterialList.Length; i++)
        {
            styleId.Add(controller.weaponMaterialList[i].colorIndex);
        }
        effectId.Clear();
        for (int i = 0; i < controller.specialEffectList.Length; i++)
        {
            effectId.Add(controller.specialEffectList[i].id);
        }
    }
}
